package ex.api;

/**
 * Interfejs serwisu pozwalajcego przeprowadzi analiz skupie.
 * Zakadamy, e serwis dziaa asynchronicznie.
 * Na pocztek naley do serwisu zaadowa dane.
 * Potem mona z serwisu pobra wyniki analizy.
 * W przypadku niepowodzenia wykonania jakiej metody wyrzucony zostanie wyjtek.
 * 
 * @author tkubik
 *
 */
public interface ClusterAnalysisService {
	public void setOptions(String[] options) throws ClusteringException; // ustawia opcje
	// metoda zwracajca nazw algorytmu
	public String getName();                                   
	// metoda pozwalajca przekaza dane do analizy
	// wyrzuca wyjtek, jeli aktualnie trwa przetwarzanie danych
	public void submit(DataSet ds) throws ClusteringException; 
	// metoda pozwalajca pobra wynik analizy
    // zwraca null - jeli trwa jeszcze przetwarzanie lub nie przekazano danych do analizy
	// wyrzuca wyjtek - jeli podczas przetwarzania doszo do jakich bdw
	// clear = true - jeli wyniki po pobraniu maj znikn z serwisu
    public DataSet retrieve(boolean clear) throws ClusteringException;   
}

